#pragma once

#include <list>
#include "NotifyWindowItem.h"
namespace tipupdater
{

class UpdaterDocument;



class NotifyWindowInfomation
{
public:
	NotifyWindowInfomation(UpdaterNotifyWindowItem item, UpdaterDocument *doc);
	BOOL Convert();

	const TCHAR *GetTitle();
	const TCHAR *GetCopy();
	const TCHAR *IsUpdateVisible();
	const TCHAR *IsStartPageVisible();
	const TCHAR *IsDefaultSearchVisible();
	const TCHAR *IsKeepVisible();
	const TCHAR *GetIconUrl();
	const TCHAR *GetInfoUrl();
	const TCHAR *IsShowInfo();

private:
	UpdaterDocument *m_doc;
	UpdaterNotifyWindowItem		m_item;
	CString m_IconUrl;	
	CString m_Title;	
	CString m_Copy;	
	CString m_InfoUrl;	
	BOOL	m_bShowInfo;
	BOOL	m_bUpdateVisible;
	BOOL	m_bSPVisible;
	BOOL	m_bDSVisible;
};

UpdaterNotifyWindowItem MakeNotifyChangedStartPageWindow();
UpdaterNotifyWindowItem MakeNotifyChangedDefaultSearchWindow();
UpdaterNotifyWindowItem MakeNotifyUpgradeWindow(const TCHAR *guid, bool isupdgrade);

class UpdaterNotifyWindowQueue
{
public:
	UpdaterNotifyWindowQueue(){}
	~UpdaterNotifyWindowQueue(){}

	void	AddItem( UpdaterNotifyWindowItem item )
	{
		if( Duplicate(item) )
			return;

		m_list.push_back(item);
	}

	void	RemoveItem( UpdaterNotifyWindowItem item )
	{

	}

	BOOL	Duplicate( UpdaterNotifyWindowItem item )
	{
		
		return FALSE;
	}

	BOOL	IsEmpty()
	{
		return m_list.empty();
	}

	BOOL Get(UpdaterNotifyWindowItem &item)
	{
		if( IsEmpty() )
			return FALSE;

		item = *m_list.begin();
		return TRUE;
	}

	BOOL Pop(UpdaterNotifyWindowItem &item)
	{
		if( FALSE == Get(item) )
			return FALSE;

		Pop();
		return TRUE;
	}

	void Pop()
	{
		if( IsEmpty() )
			return;

		m_list.pop_front();
	}

private:
	typedef std::list<UpdaterNotifyWindowItem>		UpdaterNotifyWindowList;
	UpdaterNotifyWindowList							m_list;
};

};